/*
    Copyright 2004,2005,2006 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>



#define VER         "0.1"
#define DECDATA     "The setup process could not create a required account called XXXXXXX.  This problem could be the result of an invalid template string.  Please check your template settings in XXXXXXX.INI and verify that they will produce a valid user account."



unsigned char *c6_pwddec(unsigned char *data);



int main(int argc, char *argv[]) {
    fputs("\n"
        "TinMessenger C6 password decoder "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(argc < 2) {
        printf("\nUsage: %s <password_codificata>\n"
            "\n", argv[0]);
        exit(1);
    }

    printf("\nPassword: %s\n\n", c6_pwddec(argv[1]));
    return(0);
}



unsigned char *c6_pwddec(unsigned char *data) {
    unsigned char   *ptr,       // input
                    *out,       // scrittura
                    *decptr,    // DECDATA
                    *decptrlim; // limite DECDATA
    int             len,
                    num;

    len       = strlen(data) >> 1;
    ptr = out = data;
    decptr    = DECDATA;
    decptrlim = decptr + sizeof(DECDATA) - 1;

    while(len--) {
        if(decptr == decptrlim) decptr = DECDATA;
        sscanf(ptr, "%2x", &num);
        *out++ = num - *decptr++;
        ptr++;
        ptr++;
    }
    *out = 0;
    return(data);
}

